From d56098fc38aadb25d6b8fc394fdfacf943fa0785 Mon Sep 17 00:00:00 2001
From: Zhang Boyang <zhangboyang.id@gmail.com>
Date: Sun, 22 May 2022 19:07:10 +0800
Subject: [PATCH] Modify Makefile to install Japanese variants

---
 Makefile      | 5 +++++
 font/Makefile | 5 +++++
 2 files changed, 10 insertions(+)

diff --git a/Makefile b/Makefile
index 0886cfd..e3cd96c 100644
--- a/Makefile
+++ b/Makefile
@@ -131,11 +131,16 @@ install: bindir libdir docdir
 	if [ ! -d font/compiled ] ; then \
 	   install -m0644 -p font/precompiled/unifont-$(VERSION).hex   $(PKGDEST)/unifont.hex && \
 	   install -m0644 -p font/precompiled/unifont-$(VERSION).bmp $(PKGDEST)/unifont.bmp ; \
+	   install -m0644 -p font/precompiled/unifont_jp-$(VERSION).hex   $(PKGDEST)/unifont_jp.hex && \
+	   install -m0644 -p font/precompiled/unifont_jp-$(VERSION).bmp $(PKGDEST)/unifont_jp.bmp ; \
 	else \
 	   install -m0644 -p font/compiled/unifont-$(VERSION).hex   $(PKGDEST)/unifont.hex && \
 	   install -m0644 -p font/compiled/unifont-$(VERSION).bmp $(PKGDEST)/unifont.bmp ; \
+	   install -m0644 -p font/compiled/unifont_jp-$(VERSION).hex   $(PKGDEST)/unifont_jp.hex && \
+	   install -m0644 -p font/compiled/unifont_jp-$(VERSION).bmp $(PKGDEST)/unifont_jp.bmp ; \
 	fi
 	gzip $(GZFLAGS) $(PKGDEST)/unifont.bmp
+	gzip $(GZFLAGS) $(PKGDEST)/unifont_jp.bmp
 
 clean:
 	$(MAKE) -C src  clean
diff --git a/font/Makefile b/font/Makefile
index aa760d5..c2d681c 100644
--- a/font/Makefile
+++ b/font/Makefile
@@ -648,6 +648,7 @@ precompiled: all
 	                  $(COMPILED_DIR)/unifont_csur-$(VERSION).pcf.gz \
 	                  $(COMPILED_DIR)/unifont_csur-$(VERSION).ttf \
 	                  $(COMPILED_DIR)/unifont_jp-$(VERSION).bdf.gz \
+	                  $(COMPILED_DIR)/unifont_jp-$(VERSION).pcf.gz \
 	                  $(COMPILED_DIR)/unifont_jp-$(VERSION).ttf \
 	                  $(COMPILED_DIR)/unifont_sample-$(VERSION).hex \
 	                  $(COMPILED_DIR)/unifont_sample-$(VERSION).bdf.gz \
@@ -693,18 +694,22 @@ install:
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/Unifont-APL8x16-$(VERSION).psf.gz $(CONSOLEDEST)/Unifont-APL8x16.psf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont-$(VERSION).pcf.gz         $(PCFDEST)/unifont.pcf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont_sample-$(VERSION).pcf.gz  $(PCFDEST)/unifont_sample.pcf.gz ; \
+	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont_jp-$(VERSION).pcf.gz      $(PCFDEST)/unifont_jp.pcf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont_csur-$(VERSION).pcf.gz    $(PCFDEST)/unifont_csur.pcf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont-$(VERSION).ttf            $(TTFDEST)/unifont.ttf ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont_sample-$(VERSION).ttf     $(TTFDEST)/unifont_sample.ttf ; \
+	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont_jp-$(VERSION).ttf         $(TTFDEST)/unifont_jp.ttf ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont_csur-$(VERSION).ttf       $(TTFDEST)/unifont_csur.ttf ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/precompiled/unifont_upper-$(VERSION).ttf      $(TTFDEST)/unifont_upper.ttf ; \
 	else \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/Unifont-APL8x16-$(VERSION).psf.gz $(CONSOLEDEST)/Unifont-APL8x16.psf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont-$(VERSION).pcf.gz         $(PCFDEST)/unifont.pcf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont_sample-$(VERSION).pcf.gz  $(PCFDEST)/unifont_sample.pcf.gz ; \
+	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont_jp-$(VERSION).pcf.gz      $(PCFDEST)/unifont_jp.pcf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont_csur-$(VERSION).pcf.gz    $(PCFDEST)/unifont_csur.pcf.gz ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont-$(VERSION).ttf            $(TTFDEST)/unifont.ttf ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont_sample-$(VERSION).ttf     $(TTFDEST)/unifont_sample.ttf ; \
+	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont_jp-$(VERSION).ttf         $(TTFDEST)/unifont_jp.ttf ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont_csur-$(VERSION).ttf       $(TTFDEST)/unifont_csur.ttf ; \
 	   $(INSTALL) -m0644 -p $(CURDIR)/$(COMPILED_DIR)/unifont_upper-$(VERSION).ttf      $(TTFDEST)/unifont_upper.ttf ; \
 	fi
-- 
2.30.2